Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/nucleation_tstep_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 3605)
@@ -1,46 +1,68 @@
+!
+! $Id$
+!
 MODULE nucleation_tstep_mod
 
 CONTAINS
 
-SUBROUTINE nucleation_rate(rhoa,t_seri,pplay,rh,a_xm,b_xm,c_xm,nucl_rate,ntot,x)
+SUBROUTINE nucleation_rate(rhoa,t_seri,pplay,rh,a_xm,b_xm,c_xm,nucl_rate,ntot_n,x_n)
 
   USE aerophys
   USE infotrac
-  USE YOMCST, ONLY : RPI, RD
+  USE YOMCST, ONLY : RPI, RD, RMD, RKBOL, RNAVO
 
   IMPLICIT NONE
 
   ! input variables
-  REAL rhoa !H2SO4 number density [molecules/cm3]
-  REAL t_seri
-  REAL pplay
-  REAL rh
+  LOGICAL, PARAMETER :: flag_new_nucl=.TRUE.
+  REAL rhoa    ! H2SO4 number density [molecules/cm3]
+  REAL t_seri  ! temperature (K)
+  REAL pplay   ! pressure (Pa)
+  REAL rh      ! relative humidity (between 0 and 1)
   REAL a_xm, b_xm, c_xm
 
   ! output variables
   REAL nucl_rate
-  REAL ntot ! total number of molecules in the critical cluster
-  REAL x    ! molefraction of H2SO4 in the critical cluster
+  REAL ntot_n ! total number of molecules in the critical cluster for neutral nucleation
+  REAL x_n    ! mole fraction of H2SO4 in the critical cluster for neutral nucleation
 
   ! local variables
-  REAL, PARAMETER                               :: k_B=1.3806E-23  ! Boltzmann constant [J/K]
-  REAL                                          :: jnuc !nucleation rate in 1/cm3s (10^-7-10^10 1/cm3s)
-  REAL                                          :: rc   !radius of the critical cluster in nm 
+  REAL jnuc_n ! nucleation rate in 1/cm3s (10^-7-10^10 1/cm3s) for neutral nucleation
+  REAL rc_n   ! radius of the critical cluster in nm for neutral nucleation
+  REAL na_n   ! sulfuric acid molecules in the neutral critical cluster (NOT IN USE)
+  LOGICAL kinetic_n ! true if kinetic neutral nucleation (NOT IN USE)
+  LOGICAL kinetic_i ! true if kinetic ion-induced nucleation (NOT IN USE)
+  REAL rhoatres ! threshold concentration of H2SO4 (1/cm^3) for neutral kinetic nucleation (NOT IN USE)
   REAL VH2SO4mol
+  REAL ntot_i, x_i, jnuc_i, rc_i, na_i, n_i ! quantities for charged nucleation (NOT IN USE)
+  REAL csi     ! Ion condensation sink (s-1) NOT IN USE
+  REAL airn    ! Air molecule concentration in (cm-3) NOT IN USE
+  REAL ipr     ! Ion pair production rate (cm-3 s-1) NOT IN USE
 
   ! call nucleation routine
-  CALL binapara(t_seri,rh,rhoa,jnuc,x,ntot,rc)
-
-  IF (ntot < 4.0) THEN
-    !set jnuc to collision rate of two H2SO4 molecules (following personal communication of Ulrike Niemeier and Hanna Vehkamäki)
-    VH2SO4mol=mH2SO4mol/(1.e-3*(a_xm+t_seri*(b_xm+t_seri*c_xm))) !cm3
-    jnuc = rhoa**2. *(3./4.*RPI)**(1./6.) *(12.*k_B*t_seri/mH2SO4mol)**0.5 &
-         & *100.*(2.*VH2SO4mol**(1./3.))**2. !1/(cm3s)
-    ntot=2.0
-    x=1.0
-  ENDIF
-
-  ! convert jnuc from particles/cm3/s to kg(H2SO4)/kgA/s
-  nucl_rate=jnuc*ntot*x*mH2SO4mol/(pplay/t_seri/RD/1.E6)
+  IF (.NOT.flag_new_nucl) THEN
+    ! Use older routine from Hanna Vehkamäki (FMI)
+    CALL binapara(t_seri,rh,rhoa,jnuc_n,x_n,ntot_n,rc_n)
+    ! when total number of molecules is too small 
+    ! then set jnuc_n to collision rate of two H2SO4 molecules (following personal communication of Ulrike Niemeier and Hanna Vehkamäki)
+    IF (ntot_n < 4.0) THEN
+      VH2SO4mol=mH2SO4mol/(1.E-3*(a_xm+t_seri*(b_xm+t_seri*c_xm))) !cm3
+      jnuc_n = rhoa**2. *(3./4.*RPI)**(1./6.) *(12.*RKBOL*t_seri/mH2SO4mol)**0.5 &
+           & *100.*(2.*VH2SO4mol**(1./3.))**2. !1/(cm3s)
+      ntot_n=2.0
+      x_n=1.0
+    ENDIF
+  ELSE
+    ! Use new routine from Anni Maattanen (LATMOS)
+    csi=0.0   ! no charged nucleation for now
+    ipr=-1.0  ! dummy value to make sure charged nucleation does not occur
+    airn=0.0  ! NOT IN USE
+!   airn=pplay/t_seri/RD/1.E3*RNAVO/RMD ! molec cm-3 (for future use, to be confirmed)
+    CALL newbinapara(t_seri,rh,rhoa,csi,airn,ipr,jnuc_n,ntot_n,jnuc_i,ntot_i, &
+                   & x_n,x_i,na_n,na_i,rc_n,rc_i,n_i,kinetic_n,kinetic_i,rhoatres)
+  ENDIF
+
+  ! convert jnuc_n from particles/cm3/s to kg(H2SO4)/kgA/s
+  nucl_rate=jnuc_n*ntot_n*x_n*mH2SO4mol/(pplay/t_seri/RD/1.E6)
 
 END SUBROUTINE nucleation_rate
@@ -55,15 +77,15 @@
   IMPLICIT NONE
 
-  ! input variables
+  ! input variable
   REAL nucl_rate
   REAL ntot ! total number of molecules in the critical cluster
-  REAL x    ! molefraction of H2SO4 in the critical cluster
+  REAL x    ! mole raction of H2SO4 in the critical cluster
   REAL dt
   REAL Vbin(nbtr_bin)
 
-  ! output variables
+  ! output variable
   REAL tr_seri(nbtr)
 
-  ! local variables
+  ! local variable
   INTEGER k
   REAL Vnew
@@ -77,5 +99,5 @@
   DO k=1, nbtr_bin 
   ! CK 20160531: bug fix for first bin
-    IF (k.LE.(nbtr_bin-1)) THEN 
+    IF (k.LE.nbtr_bin-1) THEN 
       IF (Vbin(k).LE.Vnew.AND.Vnew.LT.Vbin(k+1)) THEN
         ff(k)= Vbin(k)/Vnew*(Vbin(k+1)-Vnew)/(Vbin(k+1)-Vbin(k))
@@ -132,15 +154,15 @@
 
   REAL :: pt,t     !temperature in K (190.15-300.15K)
-  REAL :: prh,rh    !saturatio ratio of water (0.0001-1)
-  REAL,intent(in) :: rhoa_in    !sulfuric acid concentration in 1/cm3 (10^4-10^11 1/cm3)
-  REAL,intent(out) :: jnuc    !nucleation rate in 1/cm3s (10^-7-10^10 1/cm3s)
-  REAL,intent(out) :: ntot !total number of molecules in the critical cluster (ntot>4)
-  REAL,intent(out) :: x    ! molefraction of H2SO4 in the critical cluster       
-  REAL,intent(out) :: rc    !radius of the critical cluster in nm     
-  REAL :: rhotres    ! treshold concentration of h2so4 (1/cm^3)
+  REAL :: prh,rh    !saturation ratio of water (0.0001-1)
+  REAL,INTENT(IN) :: rhoa_in    !sulfuric acid concentration in 1/cm3 (10^4-10^11 1/cm3)
+  REAL,INTENT(OUT) :: jnuc    !nucleation rate in 1/cm3s (10^-7-10^10 1/cm3s)
+  REAL,INTENT(OUT) :: ntot !total number of molecules in the critical cluster (ntot>4)
+  REAL,INTENT(OUT) :: x    ! mole fraction of H2SO4 in the critical cluster       
+  REAL,INTENT(OUT) :: rc    !radius of the critical cluster in nm     
+  REAL :: rhotres    ! threshold concentration of h2so4 (1/cm^3)
                      ! which produces nucleation rate   1/(cm^3 s) as a function of rh and t 
   REAL rhoa
 
-! CK: use intermediate variables to avoid overwriting
+! CK: use intermediate variable to avoid overwriting
   t=pt
   rh=prh
@@ -178,86 +200,86 @@
   ENDIF
 
-  x=  0.7409967177282139 - 0.002663785665140117*t + 0.002010478847383187*Log(rh)  &
-       & - 0.0001832894131464668*t*Log(rh) + 0.001574072538464286*Log(rh)**2      &
-       & - 0.00001790589121766952*t*Log(rh)**2 + 0.0001844027436573778*Log(rh)**3 & 
-       & -  1.503452308794887e-6*t*Log(rh)**3 - 0.003499978417957668*Log(rhoa)    &
-       & + 0.0000504021689382576*t*Log(rhoa)
+  x=  0.7409967177282139 - 0.002663785665140117*t + 0.002010478847383187*LOG(rh)  &
+       & - 0.0001832894131464668*t*LOG(rh) + 0.001574072538464286*LOG(rh)**2      &
+       & - 0.00001790589121766952*t*LOG(rh)**2 + 0.0001844027436573778*LOG(rh)**3 &
+       & -  1.503452308794887E-6*t*LOG(rh)**3 - 0.003499978417957668*LOG(rhoa)    &
+       & + 0.0000504021689382576*t*LOG(rhoa)
 
   jnuc= 0.1430901615568665 + 2.219563673425199*t - 0.02739106114964264*t**2 +  &
        &  0.00007228107239317088*t**3 + 5.91822263375044/x +                   &
-       &  0.1174886643003278*Log(rh) + 0.4625315047693772*t*Log(rh) -          &
-       &  0.01180591129059253*t**2*Log(rh) +                                   &
-       &  0.0000404196487152575*t**3*Log(rh) + (15.79628615047088*Log(rh))/x - &
-       &  0.215553951893509*Log(rh)**2 - 0.0810269192332194*t*Log(rh)**2 +     &
-       &  0.001435808434184642*t**2*Log(rh)**2 -                               &
-       &  4.775796947178588e-6*t**3*Log(rh)**2 -                               &
-       &  (2.912974063702185*Log(rh)**2)/x - 3.588557942822751*Log(rh)**3 +    &
-       &  0.04950795302831703*t*Log(rh)**3 -                                   &
-       &  0.0002138195118737068*t**2*Log(rh)**3 +                              &
-       &  3.108005107949533e-7*t**3*Log(rh)**3 -                               &
-       &  (0.02933332747098296*Log(rh)**3)/x +                                 &
-       &  1.145983818561277*Log(rhoa) -                                        &
-       &  0.6007956227856778*t*Log(rhoa) +                                     &
-       &  0.00864244733283759*t**2*Log(rhoa) -                                 &
-       &  0.00002289467254710888*t**3*Log(rhoa) -                              &
-       &  (8.44984513869014*Log(rhoa))/x +                                     &
-       &  2.158548369286559*Log(rh)*Log(rhoa) +                                &
-       &  0.0808121412840917*t*Log(rh)*Log(rhoa) -                             &
-       &  0.0004073815255395214*t**2*Log(rh)*Log(rhoa) -                       &
-       &  4.019572560156515e-7*t**3*Log(rh)*Log(rhoa) +                        &
-       &  (0.7213255852557236*Log(rh)*Log(rhoa))/x +                           &
-       &  1.62409850488771*Log(rh)**2*Log(rhoa) -                              &
-       &  0.01601062035325362*t*Log(rh)**2*Log(rhoa) +                         &
-       &  0.00003771238979714162*t**2*Log(rh)**2*Log(rhoa) +                   &
-       &  3.217942606371182e-8*t**3*Log(rh)**2*Log(rhoa) -                     &
-       &  (0.01132550810022116*Log(rh)**2*Log(rhoa))/x +                       &
-       &  9.71681713056504*Log(rhoa)**2 -                                      &
-       &  0.1150478558347306*t*Log(rhoa)**2 +                                  &
-       &  0.0001570982486038294*t**2*Log(rhoa)**2 +                            &
-       &  4.009144680125015e-7*t**3*Log(rhoa)**2 +                             &
-       &  (0.7118597859976135*Log(rhoa)**2)/x -                                &
-       &  1.056105824379897*Log(rh)*Log(rhoa)**2 +                             &
-       &  0.00903377584628419*t*Log(rh)*Log(rhoa)**2 -                         &
-       &  0.00001984167387090606*t**2*Log(rh)*Log(rhoa)**2 +                   &
-       &  2.460478196482179e-8*t**3*Log(rh)*Log(rhoa)**2 -                     &
-       &  (0.05790872906645181*Log(rh)*Log(rhoa)**2)/x -                       &
-       &  0.1487119673397459*Log(rhoa)**3 +                                    &
-       &  0.002835082097822667*t*Log(rhoa)**3 -                                &
-       &  9.24618825471694e-6*t**2*Log(rhoa)**3 +                              &
-       &  5.004267665960894e-9*t**3*Log(rhoa)**3 -                             &
-       &  (0.01270805101481648*Log(rhoa)**3)/x
-  jnuc=exp(jnuc) !1/(cm3s)
-
-  ntot =-0.002954125078716302 - 0.0976834264241286*t + 0.001024847927067835*t**2 - 2.186459697726116e-6*t**3 -    &
-       &   0.1017165718716887/x - 0.002050640345231486*Log(rh) - 0.007585041382707174*t*Log(rh) +                 &
-       &   0.0001926539658089536*t**2*Log(rh) - 6.70429719683894e-7*t**3*Log(rh) -                                &
-       &   (0.2557744774673163*Log(rh))/x + 0.003223076552477191*Log(rh)**2 + 0.000852636632240633*t*Log(rh)**2 - &
-       &   0.00001547571354871789*t**2*Log(rh)**2 + 5.666608424980593e-8*t**3*Log(rh)**2 +                        &
-       &   (0.03384437400744206*Log(rh)**2)/x + 0.04743226764572505*Log(rh)**3 -                                  &
-       &   0.0006251042204583412*t*Log(rh)**3 + 2.650663328519478e-6*t**2*Log(rh)**3 -                            &
-       &   3.674710848763778e-9*t**3*Log(rh)**3 - (0.0002672510825259393*Log(rh)**3)/x -                          &
-       &   0.01252108546759328*Log(rhoa) + 0.005806550506277202*t*Log(rhoa) -                                     &
-       &   0.0001016735312443444*t**2*Log(rhoa) + 2.881946187214505e-7*t**3*Log(rhoa) +                           &
-       &   (0.0942243379396279*Log(rhoa))/x - 0.0385459592773097*Log(rh)*Log(rhoa) -                              &
-       &   0.0006723156277391984*t*Log(rh)*Log(rhoa) + 2.602884877659698e-6*t**2*Log(rh)*Log(rhoa) +              &
-       &   1.194163699688297e-8*t**3*Log(rh)*Log(rhoa) - (0.00851515345806281*Log(rh)*Log(rhoa))/x -              &
-       &   0.01837488495738111*Log(rh)**2*Log(rhoa) + 0.0001720723574407498*t*Log(rh)**2*Log(rhoa) -              &
-       &   3.717657974086814e-7*t**2*Log(rh)**2*Log(rhoa) -                                                       &
-       &   5.148746022615196e-10*t**3*Log(rh)**2*Log(rhoa) +                                                      &
-       &   (0.0002686602132926594*Log(rh)**2*Log(rhoa))/x - 0.06199739728812199*Log(rhoa)**2 +                    &
-       &   0.000906958053583576*t*Log(rhoa)**2 - 9.11727926129757e-7*t**2*Log(rhoa)**2 -                          &
-       &   5.367963396508457e-9*t**3*Log(rhoa)**2 - (0.007742343393937707*Log(rhoa)**2)/x +                       &
-       &   0.0121827103101659*Log(rh)*Log(rhoa)**2 - 0.0001066499571188091*t*Log(rh)*Log(rhoa)**2 +               &
-       &   2.534598655067518e-7*t**2*Log(rh)*Log(rhoa)**2 -                                                       &
-       &   3.635186504599571e-10*t**3*Log(rh)*Log(rhoa)**2 +                                                      &
-       &   (0.0006100650851863252*Log(rh)*Log(rhoa)**2)/x + 0.0003201836700403512*Log(rhoa)**3 -                  &
-       &   0.0000174761713262546*t*Log(rhoa)**3 + 6.065037668052182e-8*t**2*Log(rhoa)**3 -                        &
-       &   1.421771723004557e-11*t**3*Log(rhoa)**3 + (0.0001357509859501723*Log(rhoa)**3)/x
-  ntot=exp(ntot)
-
-  rc=exp(-1.6524245+0.42316402*x+0.33466487*log(ntot)) !nm
-
-  IF (jnuc < 1.e-7) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev'): nucleation rate < 1e-7/cm3s, using 0.0/cm3s,'
+       &  0.1174886643003278*LOG(rh) + 0.4625315047693772*t*LOG(rh) -          &
+       &  0.01180591129059253*t**2*LOG(rh) +                                   &
+       &  0.0000404196487152575*t**3*LOG(rh) + (15.79628615047088*LOG(rh))/x - &
+       &  0.215553951893509*LOG(rh)**2 - 0.0810269192332194*t*LOG(rh)**2 +     &
+       &  0.001435808434184642*t**2*LOG(rh)**2 -                               &
+       &  4.775796947178588E-6*t**3*LOG(rh)**2 -                               &
+       &  (2.912974063702185*LOG(rh)**2)/x - 3.588557942822751*LOG(rh)**3 +    &
+       &  0.04950795302831703*t*LOG(rh)**3 -                                   &
+       &  0.0002138195118737068*t**2*LOG(rh)**3 +                              &
+       &  3.108005107949533E-7*t**3*LOG(rh)**3 -                               &
+       &  (0.02933332747098296*LOG(rh)**3)/x +                                 &
+       &  1.145983818561277*LOG(rhoa) -                                        &
+       &  0.6007956227856778*t*LOG(rhoa) +                                     &
+       &  0.00864244733283759*t**2*LOG(rhoa) -                                 &
+       &  0.00002289467254710888*t**3*LOG(rhoa) -                              &
+       &  (8.44984513869014*LOG(rhoa))/x +                                     &
+       &  2.158548369286559*LOG(rh)*LOG(rhoa) +                                &
+       &  0.0808121412840917*t*LOG(rh)*LOG(rhoa) -                             &
+       &  0.0004073815255395214*t**2*LOG(rh)*LOG(rhoa) -                       &
+       &  4.019572560156515E-7*t**3*LOG(rh)*LOG(rhoa) +                        &
+       &  (0.7213255852557236*LOG(rh)*LOG(rhoa))/x +                           &
+       &  1.62409850488771*LOG(rh)**2*LOG(rhoa) -                              &
+       &  0.01601062035325362*t*LOG(rh)**2*LOG(rhoa) +                         &
+       &  0.00003771238979714162*t**2*LOG(rh)**2*LOG(rhoa) +                   &
+       &  3.217942606371182E-8*t**3*LOG(rh)**2*LOG(rhoa) -                     &
+       &  (0.01132550810022116*LOG(rh)**2*LOG(rhoa))/x +                       &
+       &  9.71681713056504*LOG(rhoa)**2 -                                      &
+       &  0.1150478558347306*t*LOG(rhoa)**2 +                                  &
+       &  0.0001570982486038294*t**2*LOG(rhoa)**2 +                            &
+       &  4.009144680125015E-7*t**3*LOG(rhoa)**2 +                             &
+       &  (0.7118597859976135*LOG(rhoa)**2)/x -                                &
+       &  1.056105824379897*LOG(rh)*LOG(rhoa)**2 +                             &
+       &  0.00903377584628419*t*LOG(rh)*LOG(rhoa)**2 -                         &
+       &  0.00001984167387090606*t**2*LOG(rh)*LOG(rhoa)**2 +                   &
+       &  2.460478196482179E-8*t**3*LOG(rh)*LOG(rhoa)**2 -                     &
+       &  (0.05790872906645181*LOG(rh)*LOG(rhoa)**2)/x -                       &
+       &  0.1487119673397459*LOG(rhoa)**3 +                                    &
+       &  0.002835082097822667*t*LOG(rhoa)**3 -                                &
+       &  9.24618825471694E-6*t**2*LOG(rhoa)**3 +                              &
+       &  5.004267665960894E-9*t**3*LOG(rhoa)**3 -                             &
+       &  (0.01270805101481648*LOG(rhoa)**3)/x
+  jnuc=EXP(jnuc) !1/(cm3s)
+
+  ntot =-0.002954125078716302 - 0.0976834264241286*t + 0.001024847927067835*t**2 - 2.186459697726116E-6*t**3 -    &
+       &   0.1017165718716887/x - 0.002050640345231486*LOG(rh) - 0.007585041382707174*t*LOG(rh) +                 &
+       &   0.0001926539658089536*t**2*LOG(rh) - 6.70429719683894E-7*t**3*LOG(rh) -                                &
+       &   (0.2557744774673163*LOG(rh))/x + 0.003223076552477191*LOG(rh)**2 + 0.000852636632240633*t*LOG(rh)**2 - &
+       &   0.00001547571354871789*t**2*LOG(rh)**2 + 5.666608424980593E-8*t**3*LOG(rh)**2 +                        &
+       &   (0.03384437400744206*LOG(rh)**2)/x + 0.04743226764572505*LOG(rh)**3 -                                  &
+       &   0.0006251042204583412*t*LOG(rh)**3 + 2.650663328519478E-6*t**2*LOG(rh)**3 -                            &
+       &   3.674710848763778E-9*t**3*LOG(rh)**3 - (0.0002672510825259393*LOG(rh)**3)/x -                          &
+       &   0.01252108546759328*LOG(rhoa) + 0.005806550506277202*t*LOG(rhoa) -                                     &
+       &   0.0001016735312443444*t**2*LOG(rhoa) + 2.881946187214505E-7*t**3*LOG(rhoa) +                           &
+       &   (0.0942243379396279*LOG(rhoa))/x - 0.0385459592773097*LOG(rh)*LOG(rhoa) -                              &
+       &   0.0006723156277391984*t*LOG(rh)*LOG(rhoa) + 2.602884877659698E-6*t**2*LOG(rh)*LOG(rhoa) +              &
+       &   1.194163699688297E-8*t**3*LOG(rh)*LOG(rhoa) - (0.00851515345806281*LOG(rh)*LOG(rhoa))/x -              &
+       &   0.01837488495738111*LOG(rh)**2*LOG(rhoa) + 0.0001720723574407498*t*LOG(rh)**2*LOG(rhoa) -              &
+       &   3.717657974086814E-7*t**2*LOG(rh)**2*LOG(rhoa) -                                                       &
+       &   5.148746022615196E-10*t**3*LOG(rh)**2*LOG(rhoa) +                                                      &
+       &   (0.0002686602132926594*LOG(rh)**2*LOG(rhoa))/x - 0.06199739728812199*LOG(rhoa)**2 +                    &
+       &   0.000906958053583576*t*LOG(rhoa)**2 - 9.11727926129757E-7*t**2*LOG(rhoa)**2 -                          &
+       &   5.367963396508457E-9*t**3*LOG(rhoa)**2 - (0.007742343393937707*LOG(rhoa)**2)/x +                       &
+       &   0.0121827103101659*LOG(rh)*LOG(rhoa)**2 - 0.0001066499571188091*t*LOG(rh)*LOG(rhoa)**2 +               &
+       &   2.534598655067518E-7*t**2*LOG(rh)*LOG(rhoa)**2 -                                                       &
+       &   3.635186504599571E-10*t**3*LOG(rh)*LOG(rhoa)**2 +                                                      &
+       &   (0.0006100650851863252*LOG(rh)*LOG(rhoa)**2)/x + 0.0003201836700403512*LOG(rhoa)**3 -                  &
+       &   0.0000174761713262546*t*LOG(rhoa)**3 + 6.065037668052182E-8*t**2*LOG(rhoa)**3 -                        &
+       &   1.421771723004557E-11*t**3*LOG(rhoa)**3 + (0.0001357509859501723*LOG(rhoa)**3)/x
+  ntot=EXP(ntot)
+
+  rc=EXP(-1.6524245+0.42316402*x+0.33466487*LOG(ntot)) !nm
+
+  IF (jnuc < 1.E-7) THEN
+!     print *,'Warning (ilon=',ilon,'ilev=',ilev'): nucleation rate < 1E-7/cm3s, using 0.0/cm3s,'
      jnuc=0.0
   ENDIF
@@ -269,9 +291,9 @@
   ENDIF
 
-  rhotres=exp( -279.2430007512709 + 11.73439886096903*rh + 22700.92970508331/t &
+  rhotres=EXP( -279.2430007512709 + 11.73439886096903*rh + 22700.92970508331/t &
        & - (1088.644983466801*rh)/t + 1.144362942094912*t                      &
        & - 0.03023314602163684*rh*t - 0.001302541390154324*t**2                &
-       & - 6.386965238433532*Log(rh) + (854.980361026715*Log(rh))/t            &
-       & + 0.00879662256826497*t*Log(rh)) !1/cm3
+       & - 6.386965238433532*LOG(rh) + (854.980361026715*LOG(rh))/t            &
+       & + 0.00879662256826497*t*LOG(rh)) !1/cm3
 
   RETURN
